#define REG_SIZE 256
#define MEM_SIZE 1024

typedef struct _vm {
    int reg[REG_SIZE];
    char mem[MEM_SIZE];
    int ip;
} vm;


#define HALT 0x00
#define ADD 0x01
#define LOADIL 0x02
#define LOADIH 0x03
#define STORE 0x04
#define LOAD 0x05
#define INDSTORE 0x06
#define INDLOAD 0x07
#define BE  0x08
#define BNE 0x09
#define BU 0x0a
#define BR 0x0b
#define PRINT 0x0c
#define SETLT 0x0d

#define SWAP 0x82
#define RANDOM 0xff

#ifndef NDEBUG
#define Debug printf
#else
#define Debug //
#endif

